Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/AckleyEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/AckleyEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/AckleyEvaluator.cs	(revision 3315)
@@ -28,9 +28,8 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Ackley Function<br/>
-  /// Domain:  [-32.768 , 32.768]^n <br/>
-  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// The Ackley function as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg
+  /// is highly multimodal. It has a single global minimum at the origin with value 0.
   /// </summary
-  [Item("AckleyEvaluator", "Evaluates the Ackley function on a given point. The optimum of this function is 0 at the origin.")]
+  [Item("AckleyEvaluator", "Evaluates the Ackley function on a given point. The optimum of this function is 0 at the origin. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
   [StorableClass]
   public class AckleyEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -78,7 +77,6 @@
       for (int i = 0; i < point.Length; i++)
         val += point[i] * point[i];
-      val *= 1.0 / point.Length;
-      val = Math.Sqrt(val);
-      val *= -0.2;
+      val /= point.Length;
+      val = -0.2 * Math.Sqrt(val);
       result -= 20 * Math.Exp(val);
 
@@ -86,5 +84,5 @@
       for (int i = 0; i < point.Length; i++)
         val += Math.Cos(2 * Math.PI * point[i]);
-      val *= 1.0 / point.Length;
+      val /= point.Length;
       result -= Math.Exp(val);
       return (result);
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BealeEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BealeEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BealeEvaluator.cs	(revision 3315)
@@ -28,9 +28,8 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Beale Function<br/>
-  /// Domain:  [-4.5 , 4.5]^2<br/>
-  /// Optimum: 0.0 at (3.0, 0.5)
+  /// The Beale function is defined for 2 dimensions with an optimum of 0 at (3, 0.5).
+  /// It is implemented as described in Moré, J.J., Garbow, B., and Hillstrom, K. 1981. Testing unconstrained optimization software. ACM Transactions on Mathematical Software 7, pp. 136-140, ACM.
   /// </summary>
-  [Item("BealeEvaluator", "Evaluates the Beale function on a given point. The optimum of this function is 0 at (3,0.5).")]
+  [Item("BealeEvaluator", "Evaluates the Beale function on a given point. The optimum of this function is 0 at (3,0.5). It is implemented as described in Moré, J.J., Garbow, B., and Hillstrom, K. 1981. Testing unconstrained optimization software. ACM Transactions on Mathematical Software 7, pp. 136-140, ACM.")]
   [StorableClass]
   public class BealeEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -72,5 +71,9 @@
     /// <returns>The result value of the Beale function at the given point.</returns>
     public static double Apply(RealVector point) {
-      return Math.Pow(1.5 - point[0] * (1 - point[1]), 2) + Math.Pow(2.25 - point[0] * (1 - (point[1] * point[1])), 2) + Math.Pow((2.625 - point[0] * (1 - (point[1] * point[1] * point[1]))), 2);
+      double x1 = point[0], x2 = point[1];
+      double f1 = 1.5 - x1 * (1 - x2);
+      double f2 = 2.25 - x1 * (1 - x2 * x2);
+      double f3 = 2.625 - x1 * (1 - x2 * x2 * x2);
+      return (f1 * f1) + (f2 * f2) + (f3 * f3);
     }
 
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BoothEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BoothEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/BoothEvaluator.cs	(revision 3315)
@@ -28,9 +28,7 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Booth Function<br/>
-  /// Domain:  [-10.0 , 10.0]^2<br/>
-  /// Optimum: 0.0 at (1.0, 3.0)
+  /// The Booth function is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page816.htm, last accessed April 12th, 2010.
   /// </summary>
-  [Item("BoothEvaluator", "Evaluates the Booth function on a given point. The optimum of this function is 0 at (1,3).")]
+  [Item("BoothEvaluator", "Evaluates the Booth function on a given point. The optimum of this function is 0 at (1,3). It is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page816.htm, last accessed April 12th, 2010.")]
   [StorableClass]
   public class BoothEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -72,5 +70,6 @@
     /// <returns>The result value of the Booth function at the given point.</returns>
     public static double Apply(RealVector point) {
-      return Math.Pow(point[0] + 2 * point[1] - 7, 2) + Math.Pow(2 * point[0] + point[1] - 5, 2);
+      return (point[0] + 2 * point[1] - 7) * (point[0] + 2 * point[1] - 7)
+        + (2 * point[0] + point[1] - 5) * (2 * point[0] + point[1] - 5);
     }
 
Index: unk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/GriewangkEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/GriewangkEvaluator.cs	(revision 3314)
+++ 	(revision )
@@ -1,99 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.RealVectorEncoding;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Problems.TestFunctions {
-  /// <summary>
-  /// Griewangk Function<br/>
-  /// Domain:  [-600.0 , 600.0]^n<br/>
-  /// Optimum: 0.0 at (0, 0, ..., 0)
-  /// </summary>
-  [Item("GriewangkEvaluator", "Evaluates the Griewangk function on a given point. The optimum of this function is 0 at the origin.")]
-  [StorableClass]
-  public class GriewangkEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
-    /// <summary>
-    /// Returns false as the Griewangk function is a minimization problem.
-    /// </summary>
-    public override bool Maximization {
-      get { return false; }
-    }
-    /// <summary>
-    /// Gets the optimum function value (0).
-    /// </summary>
-    public override double BestKnownQuality {
-      get { return 0; }
-    }
-    /// <summary>
-    /// Gets the lower and upper bound of the function.
-    /// </summary>
-    public override DoubleMatrix Bounds {
-      get { return new DoubleMatrix(new double[,] { { -600, 600 } }); }
-    }
-    /// <summary>
-    /// Gets the minimum problem size (2).
-    /// </summary>
-    public override int MinimumProblemSize {
-      get { return 2; }
-    }
-    /// <summary>
-    /// Gets the (theoretical) maximum problem size (2^31 - 1).
-    /// </summary>
-    public override int MaximumProblemSize {
-      get { return int.MaxValue; }
-    }
-
-    /// <summary>
-    /// Evaluates the test function for a specific <paramref name="point"/>.
-    /// </summary>
-    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
-    /// <returns>The result value of the Griewangk function at the given point.</returns>
-    public static double Apply(RealVector point) {
-      double result = 0;
-      double val = 0;
-
-      for (int i = 0; i < point.Length; i++)
-        result += point[i] * point[i];
-      result = result / 4000;
-
-      val = Math.Cos(point[0]);
-      for (int i = 1; i < point.Length; i++)
-        val *= Math.Cos(point[i] / Math.Sqrt(i + 1));
-
-      result = result - val + 1;
-      return (result);
-    }
-
-    /// <summary>
-    /// Evaluates the test function for a specific <paramref name="point"/>.
-    /// </summary>
-    /// <remarks>Calls <see cref="Apply"/>.</remarks>
-    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
-    /// <returns>The result value of the Griewangk function at the given point.</returns>
-    protected override double EvaluateFunction(RealVector point) {
-      return Apply(point);
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/GriewankEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/GriewankEvaluator.cs	(revision 3315)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/GriewankEvaluator.cs	(revision 3315)
@@ -0,0 +1,136 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.TestFunctions {
+  /// <summary>
+  /// The Griewank function is introduced in Griewank, A.O. 1981. Generalized descent for global optimization. Journal of Optimization Theory and Applications 34, pp. 11-39.
+  /// It is a multimodal fitness function in the range [-600,600]^n.
+  /// Here it is implemented as described (without the modifications) in Locatelli, M. 2003. A note on the Griewank test function. Journal of Global Optimization 25, pp. 169-174, Springer.
+  /// </summary>
+  [Item("GriewankEvaluator", "Evaluates the Griewank function on a given point. The optimum of this function is 0 at the origin. It is introduced by Griewank A.O. 1981 and implemented as described (without the modifications) in Locatelli, M. 2003. A note on the Griewank test function. Journal of Global Optimization 25, pp. 169-174, Springer.")]
+  [StorableClass]
+  public class GriewankEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
+    /// <summary>
+    /// Returns false as the Griewangk function is a minimization problem.
+    /// </summary>
+    public override bool Maximization {
+      get { return false; }
+    }
+    /// <summary>
+    /// Gets the optimum function value (0).
+    /// </summary>
+    public override double BestKnownQuality {
+      get { return 0; }
+    }
+    /// <summary>
+    /// Gets the lower and upper bound of the function.
+    /// </summary>
+    public override DoubleMatrix Bounds {
+      get { return new DoubleMatrix(new double[,] { { -600, 600 } }); }
+    }
+    /// <summary>
+    /// Gets the minimum problem size (1).
+    /// </summary>
+    public override int MinimumProblemSize {
+      get { return 1; }
+    }
+    /// <summary>
+    /// Gets the (theoretical) maximum problem size (2^31 - 1).
+    /// </summary>
+    public override int MaximumProblemSize {
+      get { return int.MaxValue; }
+    }
+
+    /// <summary>
+    /// If dimension of the problem is less or equal than 100 the values of Math.Sqrt(i + 1) are precomputed.
+    /// </summary>
+    private double[] sqrts;
+
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Griewangk function at the given point.</returns>
+    public static double Apply(RealVector point) {
+      double result = 0;
+      double val = 0;
+
+      for (int i = 0; i < point.Length; i++)
+        result += point[i] * point[i];
+      result = result / 4000;
+
+      val = Math.Cos(point[0]);
+      for (int i = 1; i < point.Length; i++)
+        val *= Math.Cos(point[i] / Math.Sqrt(i + 1));
+
+      result = result - val + 1;
+      return result;
+    }
+
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>. It uses an array of precomputed values for Math.Sqrt(i + 1) with i = 0..N
+    /// </summary>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <param name="sqrts">The precomputed array of square roots.</param>
+    /// <returns>The result value of the Griewangk function at the given point.</returns>
+    private static double Apply(RealVector point, double[] sqrts) {
+      double result = 0;
+      double val = 0;
+
+      for (int i = 0; i < point.Length; i++)
+        result += point[i] * point[i];
+      result = result / 4000;
+
+      val = Math.Cos(point[0]);
+      for (int i = 1; i < point.Length; i++)
+        val *= Math.Cos(point[i] / sqrts[i]);
+
+      result = result - val + 1;
+      return result;
+    }
+
+    /// <summary>
+    /// Evaluates the test function for a specific <paramref name="point"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="Apply"/>.</remarks>
+    /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
+    /// <returns>The result value of the Griewangk function at the given point.</returns>
+    protected override double EvaluateFunction(RealVector point) {
+      if (point.Length > 100)
+        return Apply(point);
+      else {
+        if (sqrts == null || sqrts.Length < point.Length) ComputeSqrts(point.Length);
+        return Apply(point, sqrts);
+      }
+    }
+
+    private void ComputeSqrts(int length) {
+      sqrts = new double[length];
+      for (int i = 0; i < length; i++) sqrts[i] = Math.Sqrt(i + 1);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/LevyEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/LevyEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/LevyEvaluator.cs	(revision 3315)
@@ -28,9 +28,7 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Levy Function<br/>
-  /// Domain:  [-10.0 , 10.0]^n<br/>
-  /// Optimum: 0.0 at (1.0, 1.0, ..., 1.0)
+  /// The Levy function is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page2056.htm, last accessed April 12th, 2010.
   /// </summary>
-  [Item("LevyEvaluator", "Evaluates the Levy function on a given point. The optimum of this function is 0 at (1,1,...,1).")]
+  [Item("LevyEvaluator", "Evaluates the Levy function on a given point. The optimum of this function is 0 at (1,1,...,1). It is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page2056.htm, last accessed April 12th, 2010.")]
   [StorableClass]
   public class LevyEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -80,8 +78,9 @@
       }
 
-      s = Math.Pow(Math.Sin(Math.PI * z[1]), 2);
+      s = Math.Sin(Math.PI * z[0]);
+      s *= s;
 
       for (int i = 0; i < length - 1; i++) {
-        s += Math.Pow(z[i] - 1, 2) * (1 + 10 * Math.Pow(Math.Sin(Math.PI * z[i] + 1), 2));
+        s += (z[i] - 1) * (z[i] - 1) * (1 + 10 * Math.Pow(Math.Sin(Math.PI * z[i] + 1), 2));
       }
 
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/MatyasEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/MatyasEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/MatyasEvaluator.cs	(revision 3315)
@@ -28,9 +28,7 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Matyas Function<br/>
-  /// Domain:  [-10.0 , 10.0]^2<br/>
-  /// Optimum: 0.0 at (0.0, 0.0)
+  /// The Matyas function is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page2213.htm, last accessed April 12th, 2010.
   /// </summary>
-  [Item("MatyasEvaluator", "Evaluates the Matyas function on a given point. The optimum of this function is 0 at the origin.")]
+  [Item("MatyasEvaluator", "Evaluates the Matyas function on a given point. The optimum of this function is 0 at the origin. It is implemented as described on http://www-optima.amp.i.kyoto-u.ac.jp/member/student/hedar/Hedar_files/TestGO_files/Page2213.htm, last accessed April 12th, 2010.")]
   [StorableClass]
   public class MatyasEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RastriginEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RastriginEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RastriginEvaluator.cs	(revision 3315)
@@ -25,12 +25,12 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Parameters;
 
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Rastrigin Function<br/>
-  /// Domain:  [-5.12 , 5.12]^n <br/>
-  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// The generalized Rastrigin function y = Sum((x_i)^2 + A * (1 - Cos(2pi*x_i))) is a highly multimodal function that has its optimal value 0 at the origin.
+  /// It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.
   /// </summary
-  [Item("RastriginEvaluator", "Evaluates the Rastrigin function on a given point. The optimum of this function is 0 at the origin.")]
+  [Item("RastriginEvaluator", "Evaluates the generalized Rastrigin function y = Sum((x_i)^2 + A * (1 - Cos(2pi*x_i))) on a given point. The optimum of this function is 0 at the origin. It is implemented as described in Eiben, A.E. and Smith, J.E. 2003. Introduction to Evolutionary Computation. Natural Computing Series, Springer-Verlag Berlin Heidelberg.")]
   [StorableClass]
   public class RastriginEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -65,4 +65,25 @@
       get { return int.MaxValue; }
     }
+    /// <summary>
+    /// The parameter A is a parameter of the objective function y = Sum((x_i)^2 + A * (1 - Cos(2pi*x_i))). Default is A = 10.
+    /// </summary>
+    public ValueParameter<DoubleValue> AParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["A"]; }
+    }
+    /// <summary>
+    /// The parameter A is a parameter of the objective function y = Sum((x_i)^2 + A * (1 - Cos(2pi*x_i))). Default is A = 10.
+    /// </summary>
+    public DoubleValue A {
+      get { return AParameter.Value; }
+      set { if (value != null) AParameter.Value = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of the RastriginEvaluator with one parameter (<c>A</c>).
+    /// </summary>
+    public RastriginEvaluator()
+      : base() {
+      Parameters.Add(new ValueParameter<DoubleValue>("A", "The parameter A is a parameter of the objective function y = Sum((x_i)^2 + A * (1 - Cos(2pi*x_i))). Default is A = 10.", new DoubleValue(10)));
+    }
 
     /// <summary>
@@ -71,9 +92,9 @@
     /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
     /// <returns>The result value of the Rastrigin function at the given point.</returns>
-    public static double Apply(RealVector point) {
-      double result = 10 * point.Length;
+    public static double Apply(RealVector point, double a) {
+      double result = a * point.Length;
       for (int i = 0; i < point.Length; i++) {
         result += point[i] * point[i];
-        result -= 10 * Math.Cos(2 * Math.PI * point[i]);
+        result -= a * Math.Cos(2 * Math.PI * point[i]);
       }
       return (result);
@@ -87,5 +108,5 @@
     /// <returns>The result value of the Rastrigin function at the given point.</returns>
     protected override double EvaluateFunction(RealVector point) {
-      return Apply(point);
+      return Apply(point, A.Value);
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RosenbrockEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RosenbrockEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/RosenbrockEvaluator.cs	(revision 3315)
@@ -28,9 +28,11 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Rosenbrock Function<br/>
-  /// Domain:  [-2.048 , 2.048]^n<br/>
-  /// Optimum: 0.0 at (1, 1, ..., 1)
+  /// The Rosenbrock function features a flat valley in which the global optimum is located.
+  /// It is implemented as generalized Rosenbrock function as for example given in Shang, Y.-W. and Qiu, Y.-H. 2006. A Note on the Extended Rosenbrock Function. Evolutionary Computation 14, pp. 119-126, MIT Press.
   /// </summary>
-  [Item("RosenbrockEvaluator", "Evaluates the Rosenbrock function on a given point. The optimum of this function is 0 at (1,1,...,1).")]
+  [Item("RosenbrockEvaluator", @"The Rosenbrock function features a flat valley in which the global optimum is located.
+For 2 and 3 dimensions the optimum of this function is 0 at (1,1,...,1), for 4 to 30 dimensions there is an additional local minimum.
+It is unknown how many local minima there are for dimensions greater than 30.
+It is implemented as generalized Rosenbrock function as for example given in Shang, Y.-W. and Qiu, Y.-H. 2006. A Note on the Extended Rosenbrock Function. Evolutionary Computation 14, pp. 119-126, MIT Press.")]
   [StorableClass]
   public class RosenbrockEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
@@ -74,6 +76,6 @@
       double result = 0;
       for (int i = 0; i < point.Length - 1; i++) {
-        result += 100 * (point[i + 1] - point[i] * point[i]) * (point[i + 1] - point[i] * point[i]);
-        result += (1 - point[i]) * (1 - point[i]);
+        result += 100 * (point[i] * point[i] - point[i + 1]) * (point[i] * point[i] - point[i + 1]);
+        result += (point[i] - 1) * (point[i] - 1);
       }
       return result;
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SchwefelEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SchwefelEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SchwefelEvaluator.cs	(revision 3315)
@@ -28,9 +28,7 @@
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Schwefel Function (Sine Root)<br/>
-  /// Domain:  [-500.0 , 500.0]^n<br/>
-  /// Optimum: 0.0 at (420.968746453712, 420.968746453712, ..., 420.968746453712)
+  /// The Schwefel function (sine root) is implemented as described in Affenzeller, M. and Wagner, S. 2005. Offspring Selection: A New Self-Adaptive Selection Scheme for Genetic Algorithms.  Ribeiro, B., Albrecht, R. F., Dobnikar, A., Pearson, D. W., and Steele, N. C. (eds.). Adaptive and Natural Computing Algorithms, pp. 218-221, Springer.
   /// </summary>
-  [Item("SchwefelEvaluator", "Evaluates the Schwefel function on a given point. The optimum of this function is 0 at (420.968746453712,420.968746453712,...,420.968746453712).")]
+  [Item("SchwefelEvaluator", "Evaluates the Schwefel function (sine root) on a given point. The optimum of this function is 0 at (420.968746453712,420.968746453712,...,420.968746453712). It is implemented as described in Affenzeller, M. and Wagner, S. 2005. Offspring Selection: A New Self-Adaptive Selection Scheme for Genetic Algorithms.  Ribeiro, B., Albrecht, R. F., Dobnikar, A., Pearson, D. W., and Steele, N. C. (eds.). Adaptive and Natural Computing Algorithms, pp. 218-221, Springer.")]
   [StorableClass]
   public class SchwefelEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SphereEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SphereEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/Evaluators/SphereEvaluator.cs	(revision 3315)
@@ -25,16 +25,16 @@
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Parameters;
 
 namespace HeuristicLab.Problems.TestFunctions {
   /// <summary>
-  /// Sphere Function<br/>
-  /// Domain:  [-5.12 , 5.12]^n<br/>
-  /// Optimum: 0.0 at (0, 0, ..., 0)
+  /// The sphere function is a unimodal function that has its optimum at the origin.
+  /// It is implemented as described in Beyer, H.-G. and Schwefel, H.-P. 2002. Evolution Strategies - A Comprehensive Introduction Natural Computing, 1, pp. 3-52.
   /// </summary>
-  [Item("SphereEvaluator", "Evaluates the Sphere function on a given point. The optimum of this function is 0 at the origin.")]
+  [Item("SphereEvaluator", "Evaluates the Sphere function y = C * ||X||^Alpha on a given point. The optimum of this function is 0 at the origin. It is implemented as described in Beyer, H.-G. and Schwefel, H.-P. 2002. Evolution Strategies - A Comprehensive Introduction Natural Computing, 1, pp. 3-52.")]
   [StorableClass]
   public class SphereEvaluator : SingleObjectiveTestFunctionProblemEvaluator {
     /// <summary>
-    /// Returns false as the Rosenbrock function is a minimization problem.
+    /// Returns false as the Sphere function is a minimization problem.
     /// </summary>
     public override bool Maximization {
@@ -65,5 +65,39 @@
       get { return int.MaxValue; }
     }
+    /// <summary>
+    /// The parameter C modifies the steepness of the objective function y = C * ||X||^Alpha. Default is C = 1.
+    /// </summary>
+    public ValueParameter<DoubleValue> CParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["C"]; }
+    }
+    /// <summary>
+    /// The parameter Alpha modifies the steepness of the objective function y = C * ||X||^Alpha. Default is Alpha = 2.
+    /// </summary>
+    public ValueParameter<DoubleValue> AlphaParameter {
+      get { return (ValueParameter<DoubleValue>)Parameters["Alpha"]; }
+    }
+    /// <summary>
+    /// The parameter C modifies the steepness of the objective function y = C * ||X||^Alpha. Default is C = 1.
+    /// </summary>
+    public DoubleValue C {
+      get { return CParameter.Value; }
+      set { if (value != null) CParameter.Value = value; }
+    }
+    /// <summary>
+    /// The parameter Alpha modifies the steepness of the objective function y = C * ||X||^Alpha. Default is Alpha = 2.
+    /// </summary>
+    public DoubleValue Alpha {
+      get { return AlphaParameter.Value; }
+      set { if (value != null) AlphaParameter.Value = value; }
+    }
 
+    /// <summary>
+    /// Initializes a new instance of the SphereEvaluator with two parameters (<c>C</c> and <c>Alpha</c>).
+    /// </summary>
+    public SphereEvaluator()
+      : base() {
+      Parameters.Add(new ValueParameter<DoubleValue>("C", "The parameter C modifies the steepness of the objective function y = C * ||X||^Alpha. Default is C = 1.", new DoubleValue(1)));
+      Parameters.Add(new ValueParameter<DoubleValue>("Alpha", "The parameter Alpha modifies the steepness of the objective function y = C * ||X||^Alpha. Default is Alpha = 2.", new DoubleValue(2)));
+    }
     /// <summary>
     /// Evaluates the test function for a specific <paramref name="point"/>.
@@ -71,9 +105,10 @@
     /// <param name="point">N-dimensional point for which the test function should be evaluated.</param>
     /// <returns>The result value of the Sphere function at the given point.</returns>
-    public static double Apply(RealVector point) {
+    public static double Apply(RealVector point, double c, double alpha) {
       double result = 0;
       for (int i = 0; i < point.Length; i++)
         result += point[i] * point[i];
-      return result;
+      if (alpha != 2) result = Math.Pow(Math.Sqrt(result), alpha);
+      return c * result;
     }
 
@@ -85,5 +120,5 @@
     /// <returns>The result value of the Sphere function at the given point.</returns>
     protected override double EvaluateFunction(RealVector point) {
-      return Apply(point);
+      return Apply(point, C.Value, Alpha.Value);
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/HeuristicLab.Problems.TestFunctions-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/HeuristicLab.Problems.TestFunctions-3.3.csproj	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/HeuristicLab.Problems.TestFunctions-3.3.csproj	(revision 3315)
@@ -87,5 +87,5 @@
     <Compile Include="Evaluators\BealeEvaluator.cs" />
     <Compile Include="Evaluators\BoothEvaluator.cs" />
-    <Compile Include="Evaluators\GriewangkEvaluator.cs" />
+    <Compile Include="Evaluators\GriewankEvaluator.cs" />
     <Compile Include="Evaluators\LevyEvaluator.cs" />
     <Compile Include="Evaluators\MatyasEvaluator.cs" />
@@ -105,4 +105,5 @@
     <Compile Include="MoveEvaluators\BealeAdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\BoothAdditiveMoveEvaluator.cs" />
+    <Compile Include="MoveEvaluators\GriewankAdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\ZakharovAdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\SumSquaresAdditiveMoveEvaluator.cs" />
@@ -113,5 +114,4 @@
     <Compile Include="MoveEvaluators\RastriginAdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\LevyAdditiveMoveEvaluator.cs" />
-    <Compile Include="MoveEvaluators\GriewangkAdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\AdditiveMoveEvaluator.cs" />
     <Compile Include="MoveEvaluators\RealVectorAdditiveMoveWrapper.cs" />
Index: unk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/GriewangkAdditiveMoveEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/GriewangkAdditiveMoveEvaluator.cs	(revision 3314)
+++ 	(revision )
@@ -1,38 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Encodings.RealVectorEncoding;
-
-namespace HeuristicLab.Problems.TestFunctions {
-  [Item("GriewangkAdditiveMoveEvaluator", "Class for evaluating an additive move on the Griewangk function.")]
-  [StorableClass]
-  public class GriewangkAdditiveMoveEvaluator : AdditiveMoveEvaluator {
-    public override System.Type EvaluatorType {
-      get { return typeof(GriewangkEvaluator); }
-    }
-    protected override double Evaluate(double quality, RealVector point, AdditiveMove move) {
-      RealVectorAdditiveMoveWrapper wrapper = new RealVectorAdditiveMoveWrapper(move, point);
-      return GriewangkEvaluator.Apply(wrapper);
-    }
-  }
-}
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/GriewankAdditiveMoveEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/GriewankAdditiveMoveEvaluator.cs	(revision 3315)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/GriewankAdditiveMoveEvaluator.cs	(revision 3315)
@@ -0,0 +1,38 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Encodings.RealVectorEncoding;
+
+namespace HeuristicLab.Problems.TestFunctions {
+  [Item("GriewankAdditiveMoveEvaluator", "Class for evaluating an additive move on the Griewank function.")]
+  [StorableClass]
+  public class GriewankAdditiveMoveEvaluator : AdditiveMoveEvaluator {
+    public override System.Type EvaluatorType {
+      get { return typeof(GriewankEvaluator); }
+    }
+    protected override double Evaluate(double quality, RealVector point, AdditiveMove move) {
+      RealVectorAdditiveMoveWrapper wrapper = new RealVectorAdditiveMoveWrapper(move, point);
+      return GriewankEvaluator.Apply(wrapper);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RastriginAdditiveMoveEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RastriginAdditiveMoveEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RastriginAdditiveMoveEvaluator.cs	(revision 3315)
@@ -33,5 +33,5 @@
     protected override double Evaluate(double quality, RealVector point, AdditiveMove move) {
       RealVectorAdditiveMoveWrapper wrapper = new RealVectorAdditiveMoveWrapper(move, point);
-      return RastriginEvaluator.Apply(wrapper);
+      return RastriginEvaluator.Apply(wrapper, 10); // FIXME: the parameters have to be wired
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/SphereAdditiveMoveEvaluator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/SphereAdditiveMoveEvaluator.cs	(revision 3314)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/SphereAdditiveMoveEvaluator.cs	(revision 3315)
@@ -33,5 +33,5 @@
     protected override double Evaluate(double quality, RealVector point, AdditiveMove move) {
       RealVectorAdditiveMoveWrapper wrapper = new RealVectorAdditiveMoveWrapper(move, point);
-      return SphereEvaluator.Apply(wrapper);
+      return SphereEvaluator.Apply(wrapper, 1, 2); // FIXME: the parameters have to be wired.
     }
   }
